DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Tree View - Search

To add a search bar to the JavaScript TreeView and customize the search functionality, do the following:

  • Set the searchEnabled property to true.

  • Use the searchMode property to specify whether items should contain (default), start with, or match the search string. In this example, you can switch between search modes in the drop-down menu.

  • Configure the searchExpr property to specify custom search fields. The default search field is text.

Backend API
$(() => { const treeView = $('#treeview').dxTreeView({ items: products, width: 500, searchEnabled: true, }).dxTreeView('instance'); $('#searchMode').dxSelectBox({ items: ['contains', 'startswith', 'equals'], value: 'contains', inputAttr: { 'aria-label': 'Search Mode' }, onValueChanged(data) { treeView.option('searchMode', data.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="treeview"></div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Search mode</span> <div id="searchMode"></div> </div> </div> </div> </body> </html>
#treeview { height: 400px; } .options { padding: 20px; position: absolute; bottom: 0; right: 0; width: 260px; top: 0; background-color: var(--dx-datagrid-row-alternation-bg); } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; } .option > .dx-selectbox { display: inline-block; vertical-align: middle; max-width: 350px; width: 100%; margin-top: 5px; }
const products = [{ id: '1', text: 'Stores', expanded: true, items: [{ id: '1_1', text: 'Super Mart of the West', expanded: true, items: [{ id: '1_1_1', text: 'Video Players', items: [{ id: '1_1_1_1', text: 'HD Video Player', price: 220, }, { id: '1_1_1_2', text: 'SuperHD Video Player', price: 270, }], }, { id: '1_1_2', text: 'Televisions', items: [{ id: '1_1_2_1', text: 'SuperLCD 42', price: 1200, }, { id: '1_1_2_2', text: 'SuperLED 42', price: 1450, }, { id: '1_1_2_3', text: 'SuperLED 50', price: 1600, }, { id: '1_1_2_4', text: 'SuperLCD 55', price: 1350, }, { id: '1_1_2_5', text: 'SuperLCD 70', price: 4000, }], }, { id: '1_1_3', text: 'Monitors', items: [{ id: '1_1_3_1', text: '19"', items: [{ id: '1_1_3_1_1', text: 'DesktopLCD 19', price: 160, }], }, { id: '1_1_3_2', text: '21"', items: [{ id: '1_1_3_2_1', text: 'DesktopLCD 21', price: 170, }, { id: '1_1_3_2_2', text: 'DesktopLED 21', price: 175, }], }], }, { id: '1_1_4', text: 'Projectors', items: [{ id: '1_1_4_1', text: 'Projector Plus', price: 550, }, { id: '1_1_4_2', text: 'Projector PlusHD', price: 750, }], }], }, { id: '1_2', text: 'Braeburn', items: [{ id: '1_2_1', text: 'Video Players', items: [{ id: '1_2_1_1', text: 'HD Video Player', price: 240, }, { id: '1_2_1_2', text: 'SuperHD Video Player', price: 300, }], }, { id: '1_2_2', text: 'Televisions', items: [{ id: '1_2_2_1', text: 'SuperPlasma 50', price: 1800, }, { id: '1_2_2_2', text: 'SuperPlasma 65', price: 3500, }], }, { id: '1_2_3', text: 'Monitors', items: [{ id: '1_2_3_1', text: '19"', items: [{ id: '1_2_3_1_1', text: 'DesktopLCD 19', price: 170, }], }, { id: '1_2_3_2', text: '21"', items: [{ id: '1_2_3_2_1', text: 'DesktopLCD 21', price: 180, }, { id: '1_2_3_2_2', text: 'DesktopLED 21', price: 190, }], }], }], }, { id: '1_3', text: 'E-Mart', items: [{ id: '1_3_1', text: 'Video Players', items: [{ id: '1_3_1_1', text: 'HD Video Player', price: 220, }, { id: '1_3_1_2', text: 'SuperHD Video Player', price: 275, }], }, { id: '1_3_3', text: 'Monitors', items: [{ id: '1_3_3_1', text: '19"', items: [{ id: '1_3_3_1_1', text: 'DesktopLCD 19', price: 165, }], }, { id: '1_3_3_2', text: '21"', items: [{ id: '1_3_3_2_1', text: 'DesktopLCD 21', price: 175, }], }], }], }, { id: '1_4', text: 'Walters', items: [{ id: '1_4_1', text: 'Video Players', items: [{ id: '1_4_1_1', text: 'HD Video Player', price: 210, }, { id: '1_4_1_2', text: 'SuperHD Video Player', price: 250, }], }, { id: '1_4_2', text: 'Televisions', items: [{ id: '1_4_2_1', text: 'SuperLCD 42', price: 1100, }, { id: '1_4_2_2', text: 'SuperLED 42', price: 1400, }, { id: '1_4_2_3', text: 'SuperLED 50', price: 1500, }, { id: '1_4_2_4', text: 'SuperLCD 55', price: 1300, }, { id: '1_4_2_5', text: 'SuperLCD 70', price: 4000, }, { id: '1_4_2_6', text: 'SuperPlasma 50', price: 1700, }], }, { id: '1_4_3', text: 'Monitors', items: [{ id: '1_4_3_1', text: '19"', items: [{ id: '1_4_3_1_1', text: 'DesktopLCD 19', price: 160, }], }, { id: '1_4_3_2', text: '21"', items: [{ id: '1_4_3_2_1', text: 'DesktopLCD 21', price: 170, }, { id: '1_4_3_2_2', text: 'DesktopLED 21', price: 180, }], }], }, { id: '1_4_4', text: 'Projectors', items: [{ id: '1_4_4_1', text: 'Projector Plus', price: 550, }, { id: '1_4_4_2', text: 'Projector PlusHD', price: 750, }], }], }], }];

The JavaScript TreeView uses the TextBox component as a search bar. To customize it, specify TextBox properties in the searchEditorOptions object.

We do not recommend that you enable search if the JavaScript TreeView uses virtual mode or custom logic to load data on demand. In these cases, the JavaScript TreeView may not have the full dataset, and the search results include only loaded nodes.

Backend API
<dx-tree-view
#treeview
[items]="products"
[width]="500"
[searchEnabled]="true"
searchMode="contains"
></dx-tree-view>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Search mode</span>
<dx-select-box
#searchMode
[items]="['contains', 'startsWith', 'equals']"
[inputAttr]="{ 'aria-label': 'Search Mode' }"
[(value)]="treeview.searchMode"
>
</dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSelectBoxModule } from 'devextreme-angular';
import { DxTreeViewModule } from 'devextreme-angular/ui/tree-view';
import type { DxTreeViewTypes } from 'devextreme-angular/ui/tree-view';
import { Product, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTreeViewModule,
DxSelectBoxModule,
],
})
export class AppComponent {
products: Product[];
currentItem: Product;
constructor(service: Service) {
this.products = service.getProducts();
this.currentItem = this.products[0];
}
selectItem(e: DxTreeViewTypes.ItemClickEvent<Product>) {
this.currentItem = e.itemData;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #treeview {
height: 400px;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: var(--dx-datagrid-row-alternation-bg);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
::ng-deep .option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
max-width: 350px;
width: 100%;
margin-top: 5px;
}
import { Injectable } from '@angular/core';
export class Product {
id: string;
text: string;
expanded?: boolean;
items?: Product[];
price?: number;
}
const products: Product[] = [{
id: '1',
text: 'Stores',
expanded: true,
items: [{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [{
id: '1_1_1',
text: 'Video Players',
items: [{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
}, {
id: '1_1_1_2',
text: 'SuperHD Video Player',
price: 270,
}],
}, {
id: '1_1_2',
text: 'Televisions',
items: [{
id: '1_1_2_1',
text: 'SuperLCD 42',
price: 1200,
}, {
id: '1_1_2_2',
text: 'SuperLED 42',
price: 1450,
}, {
id: '1_1_2_3',
text: 'SuperLED 50',
price: 1600,
}, {
id: '1_1_2_4',
text: 'SuperLCD 55',
price: 1350,
}, {
id: '1_1_2_5',
text: 'SuperLCD 70',
price: 4000,
}],
}, {
id: '1_1_3',
text: 'Monitors',
items: [{
id: '1_1_3_1',
text: '19"',
items: [{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
price: 160,
}],
}, {
id: '1_1_3_2',
text: '21"',
items: [{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
price: 170,
}, {
id: '1_1_3_2_2',
text: 'DesktopLED 21',
price: 175,
}],
}],
}, {
id: '1_1_4',
text: 'Projectors',
items: [{
id: '1_1_4_1',
text: 'Projector Plus',
price: 550,
}, {
id: '1_1_4_2',
text: 'Projector PlusHD',
price: 750,
}],
}],
}, {
id: '1_2',
text: 'Braeburn',
items: [{
id: '1_2_1',
text: 'Video Players',
items: [{
id: '1_2_1_1',
text: 'HD Video Player',
price: 240,
}, {
id: '1_2_1_2',
text: 'SuperHD Video Player',
price: 300,
}],
}, {
id: '1_2_2',
text: 'Televisions',
items: [{
id: '1_2_2_1',
text: 'SuperPlasma 50',
price: 1800,
}, {
id: '1_2_2_2',
text: 'SuperPlasma 65',
price: 3500,
}],
}, {
id: '1_2_3',
text: 'Monitors',
items: [{
id: '1_2_3_1',
text: '19"',
items: [{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
price: 170,
}],
}, {
id: '1_2_3_2',
text: '21"',
items: [{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
price: 180,
}, {
id: '1_2_3_2_2',
text: 'DesktopLED 21',
price: 190,
}],
}],
}],
}, {
id: '1_3',
text: 'E-Mart',
items: [{
id: '1_3_1',
text: 'Video Players',
items: [{
id: '1_3_1_1',
text: 'HD Video Player',
price: 220,
}, {
id: '1_3_1_2',
text: 'SuperHD Video Player',
price: 275,
}],
}, {
id: '1_3_3',
text: 'Monitors',
items: [{
id: '1_3_3_1',
text: '19"',
items: [{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
price: 165,
}],
}, {
id: '1_3_3_2',
text: '21"',
items: [{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
price: 175,
}],
}],
}],
}, {
id: '1_4',
text: 'Walters',
items: [{
id: '1_4_1',
text: 'Video Players',
items: [{
id: '1_4_1_1',
text: 'HD Video Player',
price: 210,
}, {
id: '1_4_1_2',
text: 'SuperHD Video Player',
price: 250,
}],
}, {
id: '1_4_2',
text: 'Televisions',
items: [{
id: '1_4_2_1',
text: 'SuperLCD 42',
price: 1100,
}, {
id: '1_4_2_2',
text: 'SuperLED 42',
price: 1400,
}, {
id: '1_4_2_3',
text: 'SuperLED 50',
price: 1500,
}, {
id: '1_4_2_4',
text: 'SuperLCD 55',
price: 1300,
}, {
id: '1_4_2_5',
text: 'SuperLCD 70',
price: 4000,
}, {
id: '1_4_2_6',
text: 'SuperPlasma 50',
price: 1700,
}],
}, {
id: '1_4_3',
text: 'Monitors',
items: [{
id: '1_4_3_1',
text: '19"',
items: [{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
price: 160,
}],
}, {
id: '1_4_3_2',
text: '21"',
items: [{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
price: 170,
}, {
id: '1_4_3_2_2',
text: 'DesktopLED 21',
price: 180,
}],
}],
}, {
id: '1_4_4',
text: 'Projectors',
items: [{
id: '1_4_4_1',
text: 'Projector Plus',
price: 550,
}, {
id: '1_4_4_2',
text: 'Projector PlusHD',
price: 750,
}],
}],
}],
}];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
The TreeView uses the TextBox component as a search bar. To customize it, specify TextBox properties in the searchEditorOptions object.
We do not recommend that you enable search if the TreeView uses virtual mode or custom logic to load data on demand. In these cases, the TreeView may not have the full dataset, and the search results include only loaded nodes.

Backend API
<template>
<div>
<DxTreeView
id="treeview"
:items="products"
:width="500"
:search-enabled="true"
:search-mode="searchMode"
/>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Search mode</span>
<DxSelectBox
:items="options"
:input-attr="{ 'aria-label': 'Search Mode' }"
v-model:value="searchMode"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { type SearchMode } from 'devextreme-vue/common';
import DxTreeView from 'devextreme-vue/tree-view';
import DxSelectBox from 'devextreme-vue/select-box';
import { products } from './data.ts';
const options: SearchMode[] = ['contains', 'startswith', 'equals'];
const searchMode = ref(options[0]);
</script>
<style scoped>
#treeview {
height: 400px;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: var(--dx-datagrid-row-alternation-bg);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
max-width: 350px;
width: 100%;
margin-top: 5px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import type { Product } from './types';
export const products: Product[] = [{
id: '1',
text: 'Stores',
expanded: true,
items: [{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [{
id: '1_1_1',
text: 'Video Players',
items: [{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
}, {
id: '1_1_1_2',
text: 'SuperHD Video Player',
price: 270,
}],
}, {
id: '1_1_2',
text: 'Televisions',
items: [{
id: '1_1_2_1',
text: 'SuperLCD 42',
price: 1200,
}, {
id: '1_1_2_2',
text: 'SuperLED 42',
price: 1450,
}, {
id: '1_1_2_3',
text: 'SuperLED 50',
price: 1600,
}, {
id: '1_1_2_4',
text: 'SuperLCD 55',
price: 1350,
}, {
id: '1_1_2_5',
text: 'SuperLCD 70',
price: 4000,
}],
}, {
id: '1_1_3',
text: 'Monitors',
items: [{
id: '1_1_3_1',
text: '19"',
items: [{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
price: 160,
}],
}, {
id: '1_1_3_2',
text: '21"',
items: [{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
price: 170,
}, {
id: '1_1_3_2_2',
text: 'DesktopLED 21',
price: 175,
}],
}],
}, {
id: '1_1_4',
text: 'Projectors',
items: [{
id: '1_1_4_1',
text: 'Projector Plus',
price: 550,
}, {
id: '1_1_4_2',
text: 'Projector PlusHD',
price: 750,
}],
}],
}, {
id: '1_2',
text: 'Braeburn',
items: [{
id: '1_2_1',
text: 'Video Players',
items: [{
id: '1_2_1_1',
text: 'HD Video Player',
price: 240,
}, {
id: '1_2_1_2',
text: 'SuperHD Video Player',
price: 300,
}],
}, {
id: '1_2_2',
text: 'Televisions',
items: [{
id: '1_2_2_1',
text: 'SuperPlasma 50',
price: 1800,
}, {
id: '1_2_2_2',
text: 'SuperPlasma 65',
price: 3500,
}],
}, {
id: '1_2_3',
text: 'Monitors',
items: [{
id: '1_2_3_1',
text: '19"',
items: [{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
price: 170,
}],
}, {
id: '1_2_3_2',
text: '21"',
items: [{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
price: 180,
}, {
id: '1_2_3_2_2',
text: 'DesktopLED 21',
price: 190,
}],
}],
}],
}, {
id: '1_3',
text: 'E-Mart',
items: [{
id: '1_3_1',
text: 'Video Players',
items: [{
id: '1_3_1_1',
text: 'HD Video Player',
price: 220,
}, {
id: '1_3_1_2',
text: 'SuperHD Video Player',
price: 275,
}],
}, {
id: '1_3_3',
text: 'Monitors',
items: [{
id: '1_3_3_1',
text: '19"',
items: [{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
price: 165,
}],
}, {
id: '1_3_3_2',
text: '21"',
items: [{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
price: 175,
}],
}],
}],
}, {
id: '1_4',
text: 'Walters',
items: [{
id: '1_4_1',
text: 'Video Players',
items: [{
id: '1_4_1_1',
text: 'HD Video Player',
price: 210,
}, {
id: '1_4_1_2',
text: 'SuperHD Video Player',
price: 250,
}],
}, {
id: '1_4_2',
text: 'Televisions',
items: [{
id: '1_4_2_1',
text: 'SuperLCD 42',
price: 1100,
}, {
id: '1_4_2_2',
text: 'SuperLED 42',
price: 1400,
}, {
id: '1_4_2_3',
text: 'SuperLED 50',
price: 1500,
}, {
id: '1_4_2_4',
text: 'SuperLCD 55',
price: 1300,
}, {
id: '1_4_2_5',
text: 'SuperLCD 70',
price: 4000,
}, {
id: '1_4_2_6',
text: 'SuperPlasma 50',
price: 1700,
}],
}, {
id: '1_4_3',
text: 'Monitors',
items: [{
id: '1_4_3_1',
text: '19"',
items: [{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
price: 160,
}],
}, {
id: '1_4_3_2',
text: '21"',
items: [{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
price: 170,
}, {
id: '1_4_3_2_2',
text: 'DesktopLED 21',
price: 180,
}],
}],
}, {
id: '1_4_4',
text: 'Projectors',
items: [{
id: '1_4_4_1',
text: 'Projector Plus',
price: 550,
}, {
id: '1_4_4_2',
text: 'Projector PlusHD',
price: 750,
}],
}],
}],
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
export interface Product {
id: string;
text: string;
expanded?: boolean;
items?: Product[];
price?: number;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
The TreeView uses the TextBox component as a search bar. To customize it, specify TextBox properties in the searchEditorOptions object.
We do not recommend that you enable search if the TreeView uses virtual mode or custom logic to load data on demand. In these cases, the TreeView may not have the full dataset, and the search results include only loaded nodes.

Backend API
import React, { useCallback, useState } from 'react';
import type { SearchMode } from 'devextreme-react/common';
import { TreeView } from 'devextreme-react/tree-view';
import { SelectBox, type SelectBoxTypes } from 'devextreme-react/select-box';
import { products, searchModeLabel } from './data.ts';
const options: SearchMode[] = ['contains', 'startswith', 'equals'];
const App = () => {
const [value, setValue] = useState<SearchMode>('contains');
const valueChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent): void => {
setValue(e.value);
}, []);
return (
<>
<TreeView
id="treeview"
items={products}
width={500}
searchMode={value}
searchEnabled={true}
/>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Search mode</span>
<SelectBox
items={options}
inputAttr={searchModeLabel}
value={value}
onValueChanged={valueChanged}
/>
</div>
</div>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import { TreeView } from 'devextreme-react/tree-view';
import { SelectBox } from 'devextreme-react/select-box';
import { products, searchModeLabel } from './data.js';
const options = ['contains', 'startswith', 'equals'];
const App = () => {
const [value, setValue] = useState('contains');
const valueChanged = useCallback((e) => {
setValue(e.value);
}, []);
return (
<>
<TreeView
id="treeview"
items={products}
width={500}
searchMode={value}
searchEnabled={true}
/>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Search mode</span>
<SelectBox
items={options}
inputAttr={searchModeLabel}
value={value}
onValueChanged={valueChanged}
/>
</div>
</div>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Product } from './types';
export const products: Product[] = [{
id: '1',
text: 'Stores',
expanded: true,
items: [{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [{
id: '1_1_1',
text: 'Video Players',
items: [{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
}, {
id: '1_1_1_2',
text: 'SuperHD Video Player',
price: 270,
}],
}, {
id: '1_1_2',
text: 'Televisions',
items: [{
id: '1_1_2_1',
text: 'SuperLCD 42',
price: 1200,
}, {
id: '1_1_2_2',
text: 'SuperLED 42',
price: 1450,
}, {
id: '1_1_2_3',
text: 'SuperLED 50',
price: 1600,
}, {
id: '1_1_2_4',
text: 'SuperLCD 55',
price: 1350,
}, {
id: '1_1_2_5',
text: 'SuperLCD 70',
price: 4000,
}],
}, {
id: '1_1_3',
text: 'Monitors',
items: [{
id: '1_1_3_1',
text: '19"',
items: [{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
price: 160,
}],
}, {
id: '1_1_3_2',
text: '21"',
items: [{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
price: 170,
}, {
id: '1_1_3_2_2',
text: 'DesktopLED 21',
price: 175,
}],
}],
}, {
id: '1_1_4',
text: 'Projectors',
items: [{
id: '1_1_4_1',
text: 'Projector Plus',
price: 550,
}, {
id: '1_1_4_2',
text: 'Projector PlusHD',
price: 750,
}],
}],
}, {
id: '1_2',
text: 'Braeburn',
items: [{
id: '1_2_1',
text: 'Video Players',
items: [{
id: '1_2_1_1',
text: 'HD Video Player',
price: 240,
}, {
id: '1_2_1_2',
text: 'SuperHD Video Player',
price: 300,
}],
}, {
id: '1_2_2',
text: 'Televisions',
items: [{
id: '1_2_2_1',
text: 'SuperPlasma 50',
price: 1800,
}, {
id: '1_2_2_2',
text: 'SuperPlasma 65',
price: 3500,
}],
}, {
id: '1_2_3',
text: 'Monitors',
items: [{
id: '1_2_3_1',
text: '19"',
items: [{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
price: 170,
}],
}, {
id: '1_2_3_2',
text: '21"',
items: [{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
price: 180,
}, {
id: '1_2_3_2_2',
text: 'DesktopLED 21',
price: 190,
}],
}],
}],
}, {
id: '1_3',
text: 'E-Mart',
items: [{
id: '1_3_1',
text: 'Video Players',
items: [{
id: '1_3_1_1',
text: 'HD Video Player',
price: 220,
}, {
id: '1_3_1_2',
text: 'SuperHD Video Player',
price: 275,
}],
}, {
id: '1_3_3',
text: 'Monitors',
items: [{
id: '1_3_3_1',
text: '19"',
items: [{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
price: 165,
}],
}, {
id: '1_3_3_2',
text: '21"',
items: [{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
price: 175,
}],
}],
}],
}, {
id: '1_4',
text: 'Walters',
items: [{
id: '1_4_1',
text: 'Video Players',
items: [{
id: '1_4_1_1',
text: 'HD Video Player',
price: 210,
}, {
id: '1_4_1_2',
text: 'SuperHD Video Player',
price: 250,
}],
}, {
id: '1_4_2',
text: 'Televisions',
items: [{
id: '1_4_2_1',
text: 'SuperLCD 42',
price: 1100,
}, {
id: '1_4_2_2',
text: 'SuperLED 42',
price: 1400,
}, {
id: '1_4_2_3',
text: 'SuperLED 50',
price: 1500,
}, {
id: '1_4_2_4',
text: 'SuperLCD 55',
price: 1300,
}, {
id: '1_4_2_5',
text: 'SuperLCD 70',
price: 4000,
}, {
id: '1_4_2_6',
text: 'SuperPlasma 50',
price: 1700,
}],
}, {
id: '1_4_3',
text: 'Monitors',
items: [{
id: '1_4_3_1',
text: '19"',
items: [{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
price: 160,
}],
}, {
id: '1_4_3_2',
text: '21"',
items: [{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
price: 170,
}, {
id: '1_4_3_2_2',
text: 'DesktopLED 21',
price: 180,
}],
}],
}, {
id: '1_4_4',
text: 'Projectors',
items: [{
id: '1_4_4_1',
text: 'Projector Plus',
price: 550,
}, {
id: '1_4_4_2',
text: 'Projector PlusHD',
price: 750,
}],
}],
}],
}];
export const searchModeLabel = { 'aria-label': 'Search Mode' };
export type Product = {
id: string;
text: string;
expanded?: boolean;
items?: Product[];
price?: number;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const products = [
{
id: '1',
text: 'Stores',
expanded: true,
items: [
{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [
{
id: '1_1_1',
text: 'Video Players',
items: [
{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
},
{
id: '1_1_1_2',
text: 'SuperHD Video Player',
price: 270,
},
],
},
{
id: '1_1_2',
text: 'Televisions',
items: [
{
id: '1_1_2_1',
text: 'SuperLCD 42',
price: 1200,
},
{
id: '1_1_2_2',
text: 'SuperLED 42',
price: 1450,
},
{
id: '1_1_2_3',
text: 'SuperLED 50',
price: 1600,
},
{
id: '1_1_2_4',
text: 'SuperLCD 55',
price: 1350,
},
{
id: '1_1_2_5',
text: 'SuperLCD 70',
price: 4000,
},
],
},
{
id: '1_1_3',
text: 'Monitors',
items: [
{
id: '1_1_3_1',
text: '19"',
items: [
{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
price: 160,
},
],
},
{
id: '1_1_3_2',
text: '21"',
items: [
{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
price: 170,
},
{
id: '1_1_3_2_2',
text: 'DesktopLED 21',
price: 175,
},
],
},
],
},
{
id: '1_1_4',
text: 'Projectors',
items: [
{
id: '1_1_4_1',
text: 'Projector Plus',
price: 550,
},
{
id: '1_1_4_2',
text: 'Projector PlusHD',
price: 750,
},
],
},
],
},
{
id: '1_2',
text: 'Braeburn',
items: [
{
id: '1_2_1',
text: 'Video Players',
items: [
{
id: '1_2_1_1',
text: 'HD Video Player',
price: 240,
},
{
id: '1_2_1_2',
text: 'SuperHD Video Player',
price: 300,
},
],
},
{
id: '1_2_2',
text: 'Televisions',
items: [
{
id: '1_2_2_1',
text: 'SuperPlasma 50',
price: 1800,
},
{
id: '1_2_2_2',
text: 'SuperPlasma 65',
price: 3500,
},
],
},
{
id: '1_2_3',
text: 'Monitors',
items: [
{
id: '1_2_3_1',
text: '19"',
items: [
{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
price: 170,
},
],
},
{
id: '1_2_3_2',
text: '21"',
items: [
{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
price: 180,
},
{
id: '1_2_3_2_2',
text: 'DesktopLED 21',
price: 190,
},
],
},
],
},
],
},
{
id: '1_3',
text: 'E-Mart',
items: [
{
id: '1_3_1',
text: 'Video Players',
items: [
{
id: '1_3_1_1',
text: 'HD Video Player',
price: 220,
},
{
id: '1_3_1_2',
text: 'SuperHD Video Player',
price: 275,
},
],
},
{
id: '1_3_3',
text: 'Monitors',
items: [
{
id: '1_3_3_1',
text: '19"',
items: [
{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
price: 165,
},
],
},
{
id: '1_3_3_2',
text: '21"',
items: [
{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
price: 175,
},
],
},
],
},
],
},
{
id: '1_4',
text: 'Walters',
items: [
{
id: '1_4_1',
text: 'Video Players',
items: [
{
id: '1_4_1_1',
text: 'HD Video Player',
price: 210,
},
{
id: '1_4_1_2',
text: 'SuperHD Video Player',
price: 250,
},
],
},
{
id: '1_4_2',
text: 'Televisions',
items: [
{
id: '1_4_2_1',
text: 'SuperLCD 42',
price: 1100,
},
{
id: '1_4_2_2',
text: 'SuperLED 42',
price: 1400,
},
{
id: '1_4_2_3',
text: 'SuperLED 50',
price: 1500,
},
{
id: '1_4_2_4',
text: 'SuperLCD 55',
price: 1300,
},
{
id: '1_4_2_5',
text: 'SuperLCD 70',
price: 4000,
},
{
id: '1_4_2_6',
text: 'SuperPlasma 50',
price: 1700,
},
],
},
{
id: '1_4_3',
text: 'Monitors',
items: [
{
id: '1_4_3_1',
text: '19"',
items: [
{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
price: 160,
},
],
},
{
id: '1_4_3_2',
text: '21"',
items: [
{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
price: 170,
},
{
id: '1_4_3_2_2',
text: 'DesktopLED 21',
price: 180,
},
],
},
],
},
{
id: '1_4_4',
text: 'Projectors',
items: [
{
id: '1_4_4_1',
text: 'Projector Plus',
price: 550,
},
{
id: '1_4_4_2',
text: 'Projector PlusHD',
price: 750,
},
],
},
],
},
],
},
];
export const searchModeLabel = { 'aria-label': 'Search Mode' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#treeview {
height: 400px;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: var(--dx-datagrid-row-alternation-bg);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
max-width: 350px;
width: 100%;
margin-top: 5px;
}
The TreeView uses the TextBox component as a search bar. To customize it, specify TextBox properties in the searchEditorOptions object.
We do not recommend that you enable search if the TreeView uses virtual mode or custom logic to load data on demand. In these cases, the TreeView may not have the full dataset, and the search results include only loaded nodes.